"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DOMListener = void 0;

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/* eslint-disable flowtype/no-weak-types */
function addListener(target, type, listener, options) {
  target.addEventListener(type, listener, options);
}

function removeListener(target, type, listener, options) {
  target.removeEventListener(type, listener, options);
}
/* eslint-enable flowtype/no-weak-types */


class DOMListener extends _react.default.Component {
  constructor(...args) {
    var _temp;

    return _temp = super(...args), _defineProperty(this, "state", {
      options: false
    }), _temp;
  }

  static getDerivedStateFromProps(nextProps, prevState) {
    const capture = nextProps.capture,
          once = nextProps.once,
          passive = nextProps.passive;

    if (once !== undefined || passive !== undefined) {
      return {
        options: {
          capture,
          once,
          passive
        }
      };
    }

    return {
      options: !!capture
    };
  }

  componentDidMount() {
    const _this$props = this.props,
          listener = _this$props.listener,
          target = _this$props.target,
          type = _this$props.type;
    addListener(target, type, listener, this.state.options);
  }

  componentDidUpdate(prevProps, prevState) {
    const _this$props2 = this.props,
          capture = _this$props2.capture,
          listener = _this$props2.listener,
          once = _this$props2.once,
          passive = _this$props2.passive,
          target = _this$props2.target,
          type = _this$props2.type;
    const options = this.state.options;

    if (capture !== prevProps.capture || listener !== prevProps.listener || once !== prevProps.once || passive !== prevProps.passive || target !== prevProps.target || type !== prevProps.type) {
      removeListener(prevProps.target, prevProps.type, prevProps.listener, prevState.options);
      addListener(target, type, listener, options);
    }
  }

  componentWillUnmount() {
    const _this$props3 = this.props,
          listener = _this$props3.listener,
          target = _this$props3.target,
          type = _this$props3.type;
    removeListener(target, type, listener, this.state.options);
  }

  render() {
    return null;
  }

}

exports.DOMListener = DOMListener;